-- START CONFIGURATION

-- Server details:
-- Set the following parameters to match your own IGUANA instance.
local server =   {}

server.url =     'http://localhost:6543' -- The address/port of the IGUANA instance to monitor
server.user =    'admin'                 -- The username of the IGUANA instance to monitor
server.pass =    'password'              -- The password of the IGUANA instance to monitor
server.channel = 'Twilio: Example'       -- The name of the channel to monitor

-- Twilio details:
-- Set the following parameters to match your Twilio account and phone information.
-- Visit: http://www.twilio.com/ to start a free trial.
local twilio =      {}
twilio.params =     {}

twilio.url =        'https://u:p@api.twilio.com/2010-04-01/Accounts/{u}/Calls.xml' -- Your unique Twilio API URL w/ credentials
twilio.params.To=   '+19999999999'                -- Your phone number (verified with Twilio)
twilio.params.From= '+19999999999'                -- Twilio issued phone number
twilio.params.Url=  'http://iguana:6544/twilio'   -- URL of a publically accessible 'Twilio: Web Service'.

-- END CONFIGURATION

store = require 'store'

function main()

   local status = store.get('channelstatus')
   
   local request = net.http.get{
      url=server.url .. '/monitor_query?', 
      auth={username=server.user, password=server.pass}, 
      live=true
   }
   
   local result = xml.parse{data=request}
   local newStatus = ''
   for x =1, result.IguanaStatus:childCount("Channel") do
      local channel = result.IguanaStatus:child("Channel", x)
      if channel.Name:nodeValue() == server.channel then
         newStatus = channel.Status:nodeValue()
      end
   end
   
   if status ~= newStatus then     
      if status == 'on' then 
         local y = net.http.post{
            url=twilio.url, 
            parameters=twilio.params, 
            live=true
         }
      end
      store.put('channelstatus', newStatus)
   end   
   
end